"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonPatch = void 0;
const Draft_1 = require("../json-crdt-patch/Draft");
const op_1 = require("../json-patch/op");
const ObjectType_1 = require("./types/lww-object/ObjectType");
class JsonPatch {
    constructor(doc) {
        this.doc = doc;
        this.draft = new Draft_1.Draft();
    }
    fromOps(ops) {
        const draft = new Draft_1.Draft();
        const { builder } = draft;
        for (const op of ops) {
            if (op instanceof op_1.OpAdd) {
                const steps = op.path;
                if (!steps.length) {
                    builder.root(builder.json(op.value));
                    continue;
                }
                const objSteps = steps.slice(0, steps.length - 1);
                const node = this.doc.find(objSteps);
                if (node instanceof ObjectType_1.ObjectType) {
                    const key = String(steps[steps.length - 1]);
                    const value = builder.json(op.value);
                    builder.setKeys(node.id, [[key, value]]);
                    continue;
                }
            }
        }
        return draft;
    }
}
exports.JsonPatch = JsonPatch;
