import type { Document } from "../document";
import type { Path } from "../../json-pointer";
import { StringType } from "../types/rga-string/StringType";
import { PatchBuilder } from "../../json-crdt-patch/PatchBuilder";
import { Patch } from "../../json-crdt-patch/Patch";
import { StringApi } from "./StringApi";
import { ArrayType } from "../types/rga-array/ArrayType";
import { ObjectType } from "../types/lww-object/ObjectType";
import { ValueType } from "../types/lww-value/ValueType";
export declare class DocumentApi {
    private readonly doc;
    patches: Patch[];
    builder: PatchBuilder;
    constructor(doc: Document);
    commit(): this;
    flush(): Patch[];
    flushPatch(): Patch;
    patch(cb: (api: this) => void): void;
    root(json: unknown): this;
    asStr(path: Path): StringType;
    str(path: Path): StringApi;
    strObjIns(obj: StringType, index: number, substr: string): void;
    strIns(path: Path, index: number, substr: string): this;
    strObjDel(obj: StringType, index: number, length: number): void;
    strDel(path: Path, index: number, length: number): this;
    asVal(path: Path): ValueType;
    valSet(path: Path, value: unknown): this;
    asArr(path: Path): ArrayType;
    arrIns(path: Path, index: number, values: unknown[]): this;
    arrDel(path: Path, index: number, length: number): this;
    asObj(path: Path): ObjectType;
    objSet(path: Path, entries: Record<string, unknown>): this;
    objDel(path: Path, keys: string[]): this;
}
