import { LogicalTimestamp, VectorClock } from '../../../json-crdt-patch/clock';
import { Document } from '../../document';
import { JsonNode } from '../../types';
import { ConstantType } from '../../types/const/ConstantType';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { ValueType } from '../../types/lww-value/ValueType';
import { ArrayChunk } from '../../types/rga-array/ArrayChunk';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { StringChunk } from '../../types/rga-string/StringChunk';
import { StringType } from '../../types/rga-string/StringType';
import { JsonCrdtSnapshot, JsonCrdtTimestamp, RootJsonCrdtNode, JsonCrdtNode, ObjectJsonCrdtNode, ArrayJsonCrdtNode, ArrayJsonCrdtChunk, JsonCrdtRgaTombstone, ValueJsonCrdtNode, StringJsonCrdtNode, StringJsonCrdtChunk, ConstantJsonCrdtNode } from './types';
export declare class Decoder {
    decode({ clock, root }: JsonCrdtSnapshot): Document;
    protected decodeClock(timestamps: JsonCrdtTimestamp[]): VectorClock;
    protected decodeTimestamp([sessionId, time]: JsonCrdtTimestamp): LogicalTimestamp;
    protected decodeRoot(doc: Document, { id, node }: RootJsonCrdtNode): void;
    protected decodeNode(doc: Document, node: JsonCrdtNode): JsonNode;
    protected decodeObj(doc: Document, node: ObjectJsonCrdtNode): ObjectType;
    protected decodeArr(doc: Document, node: ArrayJsonCrdtNode): ArrayType;
    protected decodeArrChunk(doc: Document, c: ArrayJsonCrdtChunk | JsonCrdtRgaTombstone): ArrayChunk;
    protected decodeStr(doc: Document, node: StringJsonCrdtNode): StringType;
    protected decodeStrChunk(doc: Document, c: StringJsonCrdtChunk | JsonCrdtRgaTombstone): StringChunk;
    protected decodeVal(doc: Document, node: ValueJsonCrdtNode): ValueType;
    protected decodeConst(doc: Document, node: ConstantJsonCrdtNode): ConstantType;
}
