export class IdentifiableIndex {
    constructor() {
        this.entries = new Map();
    }
    get(id) {
        const { sessionId, time } = id;
        const map1 = this.entries;
        const map2 = map1.get(sessionId);
        if (!map2)
            return undefined;
        const operation = map2.get(time);
        if (operation)
            return operation;
        return undefined;
    }
    index(operation) {
        const { sessionId, time } = operation.id;
        let map = this.entries.get(operation.id.sessionId);
        if (!map) {
            map = new Map();
            this.entries.set(sessionId, map);
        }
        map.set(time, operation);
    }
    delete(id) {
        const { sessionId, time } = id;
        const timeMap = this.entries.get(sessionId);
        if (!timeMap)
            return;
        timeMap.delete(time);
    }
    *iterate() {
        for (const map of this.entries.values())
            yield* map.values();
    }
}
