import { Draft } from "../json-crdt-patch/Draft";
import { OpAdd } from "../json-patch/op";
import { ObjectType } from "./types/lww-object/ObjectType";
export class JsonPatch {
    constructor(doc) {
        this.doc = doc;
        this.draft = new Draft();
    }
    fromOps(ops) {
        const draft = new Draft();
        const { builder } = draft;
        for (const op of ops) {
            if (op instanceof OpAdd) {
                const steps = op.path;
                if (!steps.length) {
                    builder.root(builder.json(op.value));
                    continue;
                }
                const objSteps = steps.slice(0, steps.length - 1);
                const node = this.doc.find(objSteps);
                if (node instanceof ObjectType) {
                    const key = String(steps[steps.length - 1]);
                    const value = builder.json(op.value);
                    builder.setKeys(node.id, [[key, value]]);
                    continue;
                }
            }
        }
        return draft;
    }
}
