import { Encoder as CompactEncoder } from '../compact/Encoder';
import { Encoder as MessagePackEncoder } from '../../../json-pack/Encoder';
export class Encoder {
    constructor() {
        this.encoder = new CompactEncoder();
        this.msgPack = new MessagePackEncoder();
    }
    encode(doc) {
        const json = this.encoder.encode(doc);
        const uint8 = this.msgPack.encode(json);
        return uint8;
    }
}
