import { LogicalTimestamp } from '../../../json-crdt-patch/clock';
import { ClockDecoder } from '../../../json-crdt-patch/codec/clock/ClockDecoder';
import { Document } from '../../document';
import { JsonNode } from '../../types';
import { ConstantType } from '../../types/const/ConstantType';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { ValueType } from '../../types/lww-value/ValueType';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { StringType } from '../../types/rga-string/StringType';
export declare class Decoder {
    protected clockDecoder: ClockDecoder;
    decode(data: unknown[]): Document;
    protected ts(arr: unknown[], index: number): LogicalTimestamp;
    protected decodeNode(doc: Document, data: unknown): JsonNode;
    protected decodeObj(doc: Document, data: unknown[]): ObjectType;
    protected decodeArr(doc: Document, data: unknown[]): ArrayType;
    protected decodeStr(doc: Document, data: unknown[]): StringType;
    protected decodeVal(doc: Document, data: unknown[]): ValueType;
    protected decodeConst(doc: Document, data: unknown[]): ConstantType;
}
