import { LogicalTimestamp, VectorClock } from '../../../json-crdt-patch/clock';
import { ClockEncoder } from '../../../json-crdt-patch/codec/clock/ClockEncoder';
import { Document } from '../../document';
import { JsonNode } from '../../types';
import { ConstantType } from '../../types/const/ConstantType';
import { DocRootType } from '../../types/lww-doc-root/DocRootType';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { ValueType } from '../../types/lww-value/ValueType';
import { ArrayChunk } from '../../types/rga-array/ArrayChunk';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { StringChunk } from '../../types/rga-string/StringChunk';
import { StringType } from '../../types/rga-string/StringType';
export declare class Encoder {
    protected clock: ClockEncoder;
    encode(doc: Document): unknown[];
    protected encodeClock(clock: VectorClock): number[];
    protected ts(arr: unknown[], ts: LogicalTimestamp): void;
    protected encodeRoot(arr: unknown[], root: DocRootType): void;
    protected encodeNode(arr: unknown[], node: JsonNode): void;
    protected encodeObj(arr: unknown[], obj: ObjectType): void;
    protected encodeArr(arr: unknown[], obj: ArrayType): void;
    protected encodeArrChunk(arr: unknown[], chunk: ArrayChunk): void;
    protected encodeStr(arr: unknown[], obj: StringType): void;
    protected encodeStrChunk(arr: unknown[], chunk: StringChunk): void;
    protected encodeVal(arr: unknown[], obj: ValueType): void;
    protected encodeConst(arr: unknown[], obj: ConstantType): void;
}
