import { LogicalTimestamp, VectorClock } from '../../../json-crdt-patch/clock';
import { Document } from '../../document';
import { JsonNode } from '../../types';
import { ConstantType } from '../../types/const/ConstantType';
import { DocRootType } from '../../types/lww-doc-root/DocRootType';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { ValueType } from '../../types/lww-value/ValueType';
import { ArrayChunk } from '../../types/rga-array/ArrayChunk';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { StringChunk } from '../../types/rga-string/StringChunk';
import { StringType } from '../../types/rga-string/StringType';
import { JsonCrdtSnapshot, JsonCrdtTimestamp, RootJsonCrdtNode, JsonCrdtNode, ObjectJsonCrdtNode, ArrayJsonCrdtNode, ArrayJsonCrdtChunk, JsonCrdtRgaTombstone, ValueJsonCrdtNode, StringJsonCrdtNode, StringJsonCrdtChunk, ConstantJsonCrdtNode } from './types';
export declare class Encoder {
    encode(doc: Document): JsonCrdtSnapshot;
    encodeClock(clock: VectorClock): JsonCrdtTimestamp[];
    encodeTimestamp(ts: LogicalTimestamp): JsonCrdtTimestamp;
    encodeRoot(root: DocRootType): RootJsonCrdtNode;
    encodeNode(node: JsonNode): JsonCrdtNode;
    encodeObj(obj: ObjectType): ObjectJsonCrdtNode;
    encodeArr(obj: ArrayType): ArrayJsonCrdtNode;
    encodeArrChunk(chunk: ArrayChunk): ArrayJsonCrdtChunk | JsonCrdtRgaTombstone;
    encodeStr(obj: StringType): StringJsonCrdtNode;
    encodeStrChunk(chunk: StringChunk): StringJsonCrdtChunk | JsonCrdtRgaTombstone;
    encodeVal(obj: ValueType): ValueJsonCrdtNode;
    encodeConst(obj: ConstantType): ConstantJsonCrdtNode;
}
