import type { JsonNode } from './types';
import { IdentifiableIndex } from './IdentifiableIndex';
import { JsonCrdtPatchOperation, Patch } from '../json-crdt-patch/Patch';
import { VectorClock } from '../json-crdt-patch/clock';
import { DocRootType } from './types/lww-doc-root/DocRootType';
import { Operation } from '../json-patch';
import { Path } from '../json-pointer';
import { DocumentApi } from './api/DocumentApi';
export declare class Document {
    root: DocRootType;
    clock: VectorClock;
    nodes: IdentifiableIndex<JsonNode>;
    api: DocumentApi;
    constructor(clock?: VectorClock);
    applyPatch(patch: Patch): void;
    applyOperation(op: JsonCrdtPatchOperation): void;
    private deleteNodeTree;
    toJson(): unknown;
    clone(): Document;
    fork(): Document;
    toString(): string;
    find(steps: Path): JsonNode;
    applyJsonPatch(operations: Operation[]): void;
}
