import { LogicalTimestamp } from '../../../json-crdt-patch/clock';
import { SetObjectKeysOperation } from '../../../json-crdt-patch/operations/SetObjectKeysOperation';
import { Document } from '../../document';
import { JsonNode } from '../../types';
import { ObjectChunk } from './ObjectChunk';
export declare class ObjectType implements JsonNode {
    readonly doc: Document;
    readonly id: LogicalTimestamp;
    readonly latest: Map<string, ObjectChunk>;
    constructor(doc: Document, id: LogicalTimestamp);
    get(key: string): undefined | LogicalTimestamp;
    getId(key: string): undefined | LogicalTimestamp;
    insert(op: SetObjectKeysOperation): void;
    put(key: string, id: LogicalTimestamp, value: LogicalTimestamp): void;
    putChunk(key: string, chunk: ObjectChunk): void;
    toJson(): Record<string, unknown>;
    toString(tab?: string): string;
    clone(doc: Document): ObjectType;
    children(): IterableIterator<LogicalTimestamp>;
}
