import type { JsonNode } from '../../types';
import type { Document } from '../../document';
import { LogicalTimespan, LogicalTimestamp } from '../../../json-crdt-patch/clock';
import { DeleteOperation } from '../../../json-crdt-patch/operations/DeleteOperation';
import { InsertArrayElementsOperation } from '../../../json-crdt-patch/operations/InsertArrayElementsOperation';
import { ArrayChunk } from './ArrayChunk';
export declare class ArrayType implements JsonNode {
    readonly doc: Document;
    readonly id: LogicalTimestamp;
    start: ArrayChunk;
    end: ArrayChunk;
    constructor(doc: Document, id: LogicalTimestamp);
    insert(op: InsertArrayElementsOperation): void;
    private insertChunk;
    private splitChunk;
    delete(op: DeleteOperation): void;
    private deleteInChunk;
    findId(index: number): LogicalTimestamp;
    findValue(index: number): LogicalTimestamp;
    findIdSpans(index: number, length: number): LogicalTimespan[];
    append(chunk: ArrayChunk): void;
    toJson(): unknown[];
    clone(doc: Document): ArrayType;
    children(): IterableIterator<LogicalTimestamp>;
    chunks(): IterableIterator<ArrayChunk>;
    toString(tab?: string): string;
}
