import type { JsonNode } from '../../types';
import type { Document } from '../../document';
import { LogicalTimespan, LogicalTimestamp } from '../../../json-crdt-patch/clock';
import { DeleteOperation } from '../../../json-crdt-patch/operations/DeleteOperation';
import { InsertStringSubstringOperation } from '../../../json-crdt-patch/operations/InsertStringSubstringOperation';
import { StringChunk } from './StringChunk';
export declare class StringType implements JsonNode {
    readonly doc: Document;
    readonly id: LogicalTimestamp;
    start: StringChunk;
    end: StringChunk;
    constructor(doc: Document, id: LogicalTimestamp);
    onInsert(op: InsertStringSubstringOperation): void;
    onDelete(op: DeleteOperation): void;
    private insertChunk;
    private splitChunk;
    private deleteInChunk;
    findId(index: number): LogicalTimestamp;
    findIdSpan(index: number, length: number): LogicalTimespan[];
    append(chunk: StringChunk): void;
    toJson(): string;
    clone(doc: Document): StringType;
    children(): IterableIterator<LogicalTimestamp>;
    chunks(): IterableIterator<StringChunk>;
    toString(tab?: string): string;
}
