import { LogicalClock, LogicalTimestamp } from "./clock";
import { Patch } from "./Patch";
export declare class PatchBuilder {
    readonly clock: LogicalClock;
    readonly patch: Patch;
    constructor(clock: LogicalClock);
    obj(): LogicalTimestamp;
    arr(): LogicalTimestamp;
    str(): LogicalTimestamp;
    num(): LogicalTimestamp;
    const(value: unknown): LogicalTimestamp;
    val(value: unknown): LogicalTimestamp;
    root(value: LogicalTimestamp): LogicalTimestamp;
    setKeys(obj: LogicalTimestamp, tuples: [key: string, value: LogicalTimestamp][]): LogicalTimestamp;
    setNum(obj: LogicalTimestamp, value: number): LogicalTimestamp;
    setVal(obj: LogicalTimestamp, value: unknown): LogicalTimestamp;
    insStr(obj: LogicalTimestamp, after: LogicalTimestamp, substring: string): LogicalTimestamp;
    insArr(arr: LogicalTimestamp, after: LogicalTimestamp, elements: LogicalTimestamp[]): LogicalTimestamp;
    del(obj: LogicalTimestamp, start: LogicalTimestamp, span: number): LogicalTimestamp;
    noop(span: number): LogicalTimestamp;
    jsonObj(json: object): LogicalTimestamp;
    jsonArr(json: unknown[]): LogicalTimestamp;
    jsonStr(json: string): LogicalTimestamp;
    jsonVal(json: unknown): LogicalTimestamp;
    json(json: unknown): LogicalTimestamp;
    private pad;
}
