import type { json_string } from "ts-brand-json";
export declare class LogicalTimestamp {
    readonly sessionId: number;
    time: number;
    constructor(sessionId: number, time: number);
    isEqual(ts: LogicalTimestamp): boolean;
    compare(ts: LogicalTimestamp): -1 | 0 | 1;
    inSpan(span: number, ts: LogicalTimestamp, tsSpan: number): boolean;
    overlap(span: number, ts: LogicalTimestamp, tsSpan: number): number;
    tick(cycles: number): LogicalTimestamp;
    interval(cycles: number, span: number): LogicalTimespan;
    toString(): string;
    toDisplayString(): string;
    clock(): LogicalClock;
    compact(): string;
}
export declare class LogicalTimespan extends LogicalTimestamp {
    span: number;
    constructor(sessionId: number, time: number, span: number);
}
export declare class LogicalClock extends LogicalTimestamp {
    sessionId: number;
    time: number;
    constructor(sessionId: number, time: number);
    tick(cycles: number): LogicalTimestamp;
}
export declare class VectorClock extends LogicalClock {
    readonly clocks: Map<number, LogicalTimestamp>;
    constructor(sessionId: number, time: number);
    observe(ts: LogicalTimestamp, span: number): void;
    serialize(): json_string<number[]>;
    static deserialize(data: number[]): VectorClock;
    fork(sessionId: number): VectorClock;
    clone(): VectorClock;
}
