"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdentifiableIndex = void 0;
var tslib_1 = require("tslib");
var IdentifiableIndex = (function () {
    function IdentifiableIndex() {
        this.entries = new Map();
    }
    IdentifiableIndex.prototype.get = function (id) {
        var sessionId = id.sessionId, time = id.time;
        var map1 = this.entries;
        var map2 = map1.get(sessionId);
        if (!map2)
            return undefined;
        var operation = map2.get(time);
        if (operation)
            return operation;
        return undefined;
    };
    IdentifiableIndex.prototype.index = function (operation) {
        var _a = operation.id, sessionId = _a.sessionId, time = _a.time;
        var map = this.entries.get(operation.id.sessionId);
        if (!map) {
            map = new Map();
            this.entries.set(sessionId, map);
        }
        map.set(time, operation);
    };
    IdentifiableIndex.prototype.delete = function (id) {
        var sessionId = id.sessionId, time = id.time;
        var timeMap = this.entries.get(sessionId);
        if (!timeMap)
            return;
        timeMap.delete(time);
    };
    IdentifiableIndex.prototype.iterate = function () {
        var _a, _b, map, e_1_1;
        var e_1, _c;
        return tslib_1.__generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _d.trys.push([0, 5, 6, 7]);
                    _a = tslib_1.__values(this.entries.values()), _b = _a.next();
                    _d.label = 1;
                case 1:
                    if (!!_b.done) return [3, 4];
                    map = _b.value;
                    return [5, tslib_1.__values(map.values())];
                case 2:
                    _d.sent();
                    _d.label = 3;
                case 3:
                    _b = _a.next();
                    return [3, 1];
                case 4: return [3, 7];
                case 5:
                    e_1_1 = _d.sent();
                    e_1 = { error: e_1_1 };
                    return [3, 7];
                case 6:
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7];
                case 7: return [2];
            }
        });
    };
    return IdentifiableIndex;
}());
exports.IdentifiableIndex = IdentifiableIndex;
