"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonPatch = void 0;
var tslib_1 = require("tslib");
var Draft_1 = require("../json-crdt-patch/Draft");
var op_1 = require("../json-patch/op");
var ObjectType_1 = require("./types/lww-object/ObjectType");
var JsonPatch = (function () {
    function JsonPatch(doc) {
        this.doc = doc;
        this.draft = new Draft_1.Draft();
    }
    JsonPatch.prototype.fromOps = function (ops) {
        var e_1, _a;
        var draft = new Draft_1.Draft();
        var builder = draft.builder;
        try {
            for (var ops_1 = tslib_1.__values(ops), ops_1_1 = ops_1.next(); !ops_1_1.done; ops_1_1 = ops_1.next()) {
                var op = ops_1_1.value;
                if (op instanceof op_1.OpAdd) {
                    var steps = op.path;
                    if (!steps.length) {
                        builder.root(builder.json(op.value));
                        continue;
                    }
                    var objSteps = steps.slice(0, steps.length - 1);
                    var node = this.doc.find(objSteps);
                    if (node instanceof ObjectType_1.ObjectType) {
                        var key = String(steps[steps.length - 1]);
                        var value = builder.json(op.value);
                        builder.setKeys(node.id, [[key, value]]);
                        continue;
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (ops_1_1 && !ops_1_1.done && (_a = ops_1.return)) _a.call(ops_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return draft;
    };
    return JsonPatch;
}());
exports.JsonPatch = JsonPatch;
