"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Encoder = void 0;
var tslib_1 = require("tslib");
var Encoder_1 = require("../../../json-pack/Encoder");
var Encoder = (function (_super) {
    tslib_1.__extends(Encoder, _super);
    function Encoder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Encoder.prototype.vuint57 = function (num) {
        if (num <= 127) {
            this.u8(num);
        }
        else if (num <= 16383) {
            this.u8(128 | (num & 127));
            this.u8(num >>> 7);
        }
        else if (num <= 2097151) {
            this.u8(128 | (num & 127));
            this.u8(128 | ((num >>> 7) & 127));
            this.u8(num >>> 14);
        }
        else if (num <= 268435455) {
            this.u8(128 | (num & 127));
            this.u8(128 | ((num >>> 7) & 127));
            this.u8(128 | ((num >>> 14) & 127));
            this.u8(num >>> 21);
        }
        else {
            var lo32 = num | 0;
            if (lo32 < 0)
                lo32 += 4294967296;
            var hi32 = (num - lo32) / 4294967296;
            if (num <= 34359738367) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8((hi32 << 4) | (num >>> 28));
            }
            else if (num <= 4398046511103) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8(128 | ((hi32 & 7) << 4) | (num >>> 28));
                this.u8(hi32 >>> 3);
            }
            else if (num <= 562949953421311) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8(128 | ((hi32 & 7) << 4) | (num >>> 28));
                this.u8(128 | ((hi32 & 1016) >>> 3));
                this.u8(hi32 >>> 10);
            }
            else {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8(128 | ((hi32 & 7) << 4) | (num >>> 28));
                this.u8(128 | ((hi32 & 1016) >>> 3));
                this.u8(128 | ((hi32 & 130048) >>> 10));
                this.u8(hi32 >>> 17);
            }
        }
    };
    Encoder.prototype.vuint39 = function (num) {
        if (num <= 127) {
            this.u8(num);
        }
        else if (num <= 16383) {
            this.u8(128 | (num & 127));
            this.u8(num >>> 7);
        }
        else if (num <= 2097151) {
            this.u8(128 | (num & 127));
            this.u8(128 | ((num >>> 7) & 127));
            this.u8(num >>> 14);
        }
        else if (num <= 268435455) {
            this.u8(128 | (num & 127));
            this.u8(128 | ((num >>> 7) & 127));
            this.u8(128 | ((num >>> 14) & 127));
            this.u8(num >>> 21);
        }
        else {
            var lo32 = num | 0;
            if (lo32 < 0)
                lo32 += 4294967296;
            var hi32 = (num - lo32) / 4294967296;
            if (num <= 34359738367) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8((hi32 << 4) | (num >>> 28));
            }
            else if (num <= 4398046511103) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8(128 | ((hi32 & 7) << 4) | (num >>> 28));
                this.u8((hi32 >>> 3) & 15);
            }
        }
    };
    Encoder.prototype.b1vuint56 = function (flag, num) {
        if (num <= 63) {
            this.u8((flag ? 128 : 0) | num);
        }
        else {
            var firstByteMask = flag ? 192 : 64;
            if (num <= 8191) {
                this.u8(firstByteMask | (num & 63));
                this.u8(num >>> 6);
            }
            else if (num <= 1048575) {
                this.u8(firstByteMask | (num & 63));
                this.u8(128 | ((num >>> 6) & 127));
                this.u8(num >>> 13);
            }
            else if (num <= 134217727) {
                this.u8(firstByteMask | (num & 63));
                this.u8(128 | ((num >>> 6) & 127));
                this.u8(128 | ((num >>> 13) & 127));
                this.u8(num >>> 20);
            }
            else {
                var lo32 = num | 0;
                if (lo32 < 0)
                    lo32 += 4294967296;
                var hi32 = (num - lo32) / 4294967296;
                if (num <= 17179869183) {
                    this.u8(firstByteMask | (num & 63));
                    this.u8(128 | ((num >>> 6) & 127));
                    this.u8(128 | ((num >>> 13) & 127));
                    this.u8(128 | ((num >>> 20) & 127));
                    this.u8((hi32 << 5) | (num >>> 27));
                }
                else if (num <= 2199023255551) {
                    this.u8(firstByteMask | (num & 63));
                    this.u8(128 | ((num >>> 6) & 127));
                    this.u8(128 | ((num >>> 13) & 127));
                    this.u8(128 | ((num >>> 20) & 127));
                    this.u8(128 | ((hi32 & 3) << 5) | (num >>> 27));
                    this.u8(hi32 >>> 2);
                }
                else if (num <= 281474976710655) {
                    this.u8(firstByteMask | (num & 63));
                    this.u8(128 | ((num >>> 6) & 127));
                    this.u8(128 | ((num >>> 13) & 127));
                    this.u8(128 | ((num >>> 20) & 127));
                    this.u8(128 | ((hi32 & 3) << 5) | (num >>> 27));
                    this.u8(128 | ((hi32 & 508) >>> 2));
                    this.u8(hi32 >>> 9);
                }
                else {
                    this.u8(firstByteMask | (num & 63));
                    this.u8(128 | ((num >>> 6) & 127));
                    this.u8(128 | ((num >>> 13) & 127));
                    this.u8(128 | ((num >>> 20) & 127));
                    this.u8(128 | ((hi32 & 3) << 5) | (num >>> 27));
                    this.u8(128 | ((hi32 & 508) >>> 2));
                    this.u8(128 | ((hi32 & 130048) >>> 9));
                    this.u8(hi32 >>> 16);
                }
            }
        }
    };
    Encoder.prototype.b1vuint28 = function (flag, num) {
        if (num <= 63) {
            this.u8((flag ? 128 : 0) | num);
        }
        else {
            var firstByteMask = flag ? 192 : 64;
            if (num <= 8191) {
                this.u8(firstByteMask | (num & 63));
                this.u8(num >>> 6);
            }
            else if (num <= 1048575) {
                this.u8(firstByteMask | (num & 63));
                this.u8(128 | ((num >>> 6) & 127));
                this.u8(num >>> 13);
            }
            else {
                this.u8(firstByteMask | (num & 63));
                this.u8(128 | ((num >>> 6) & 127));
                this.u8(128 | ((num >>> 13) & 127));
                this.u8(num >>> 20);
            }
        }
    };
    return Encoder;
}(Encoder_1.Encoder));
exports.Encoder = Encoder;
