export interface JsonCrdtSnapshot {
    clock: JsonCrdtTimestamp[];
    root: RootJsonCrdtNode;
}
export declare type JsonCrdtTimestamp = [sessionId: number, time: number];
export interface RootJsonCrdtNode {
    type: 'root';
    id: JsonCrdtTimestamp;
    node: JsonCrdtNode | null;
}
export interface ObjectJsonCrdtNode {
    type: 'obj';
    id: JsonCrdtTimestamp;
    chunks: Record<string, ObjectJsonCrdtChunk>;
}
export interface ObjectJsonCrdtChunk {
    id: JsonCrdtTimestamp;
    node: JsonCrdtNode;
}
export interface ArrayJsonCrdtNode {
    type: 'arr';
    id: JsonCrdtTimestamp;
    chunks: (ArrayJsonCrdtChunk | JsonCrdtRgaTombstone)[];
}
export interface ArrayJsonCrdtChunk {
    id: JsonCrdtTimestamp;
    nodes: JsonCrdtNode[];
}
export interface StringJsonCrdtNode {
    type: 'str';
    id: JsonCrdtTimestamp;
    chunks: (StringJsonCrdtChunk | JsonCrdtRgaTombstone)[];
}
export interface StringJsonCrdtChunk {
    id: JsonCrdtTimestamp;
    value: string;
}
export interface JsonCrdtRgaTombstone {
    id: JsonCrdtTimestamp;
    span: number;
}
export interface ValueJsonCrdtNode {
    type: 'val';
    id: JsonCrdtTimestamp;
    writeId: JsonCrdtTimestamp;
    value: unknown;
}
export interface ConstantJsonCrdtNode {
    type: 'const';
    value: unknown;
}
export declare type JsonCrdtNode = ObjectJsonCrdtNode | ArrayJsonCrdtNode | StringJsonCrdtNode | ValueJsonCrdtNode | ConstantJsonCrdtNode;
